# Version 1.1.4 November 26, 2002
#
# Works only on EconLit output generated October 2002 or later
#
# This Perl 5 script was written by 
# Marc Muendler and Tiago Ribeiro
# University of California, San Diego and Berkeley, Departments of Economics
# e-mails:  muendler@econ.ucsd.edu            tribeiro@econ.berkeley.edu
# URLs:     http://econ.ucsd.edu/~muendler/   
# 
# Copyright (C) 2001 all rights reserved.
# 
# Copying of this file is authorized only if either
#  (1) you make _no_ changes to your copy, or
#  (2) if you do make any change, you name the altered file differently.
#      (You may keep the file name if you make changes only to 
#       sections that are surrounded by #--- separators.)
#
# Please report bugs (and suggested fixes, if any) to the authors.
# Note: There are two types of inactive print commands in the code:
#            "# print OUT", and 
#            "# @RM[$i]= ", the latter for output in note={} in the BibTeX file.
#       These commands may facilitate debugging when activated.
#

#-----------------------------------------------
# PLEASE ENTER OPTIONS AND FILENAME HERE as $cmd
$cmd = '-e -f -k -v download';
#-----------------------------------------------

# $cmd Command interpretation
$file= $cmd; $file =~ s/\-\w+\s+//g; 
$ext = $file; $ext =~ s/([\s\w\d\-\.]+)\.//g;
if($ext =~ m/\w+/){$ext = 'dat';}
$file=~ s/\.([\s\w\d\-]+)//;
$option = $cmd; $option =~ s/(\s+)*$file(\s+)*//g; $option =~ s/(\s+)*\.(\s+)*$ext//g;

#-----------------------------------------------------------------------------------------------------------
# CHANGE PATH NAMES for input and output files HERE
open(IN,"<c:/temp/$file.$ext")   or die "Can't open input file $file.$ext. Error ";
open(OUT,">c:/temp/$file.bib")   or die "Can't open output file $file.bib. Error ";
#-----------------------------------------------------------------------------------------------------------

$option =~ tr/A-Z/a-z/;
$option =~ s/\-[a-dg-jn-prsuw-z]//g; 
if($option =~ m/\-l/ && $option =~ m/\-k/){$option =~ s/\s+\-l/ /g;}
$option =~ s/\s\s/ /g;
if($option !~ m/\w+/){$optplot = "<none>"}
                else {$optplot=$option}
print OUT '% Input file: '. $file.'.'.$ext . "\n" ;
print OUT '% Options were: '. $optplot . "\n" ;
print OUT '%  -e: Transforms "et al." string into "{et al.}" in author=/editor items (default: no transformation)'. "\n" ;
print OUT '%  -f: Adds a File reference item (set to F) to each BibTeX entry (default: no file reference)'. "\n" ;
print OUT '%  -k: Creates BibTeX Keys from combination of author=/editor= and year= (default: running number; -k overrides -l)'. "\n" ;
print OUT '%  -l: Leaves BibTeX keys out and replaces them by a dummy that causes a BibTeX error (default: running number)'. "\n" ;
print OUT '%  -m: Does _not_ transform abbreviated Month names to full names---i.e. _no_ change of "Jan" to "January" etc. (default: transformation)'. "\n" ;
print OUT '%  -q: Changes double quotes to single quotes in title= and booktitle= (default: keep double quotes from WebSpirs)'. "\n" ;
print OUT '%  -t: Creates working paper output as TECHREPORT and not as ARTICLE (default: ARTICLE)'. "\n" ;
print OUT '%  -v: Uses volume instead of number for BOOKS and INCOLLECTION items whenever both provided by WebSpirs (default: number)'. "\n" ;
# print OUT '%  (Any further instruction was ignored.)'. "\n" ;
print OUT "\n" ;

$count=0;
$probljo=0;
$problwp=0;
$problbk=0;
$problph=0;
$problcl=0;
$noprbdt=0;

while(<IN>){

    $_ =~ s/&/\\&/g;          #Replace & for LaTeX;
    $_ =~ s/R\\&D/{R\\&D}/g;  #Replace R&D for LaTeX;
    $_ =~ s/AR\(/{AR}(/g;     #Replace AR(n) for LaTeX;
    $_ =~ s/MA\(/{MA}(/g;     #Replace MA(n) for LaTeX;

    $_ =~ s/\,\-Jr/ Jr./g;  #Replace "," in front of Jr. for BibTeX;
    $_ =~ s/\,\s+Jr/ Jr./g; #Replace "," in front of Jr. for BibTeX;

    $_ =~ s/\s+\'/ \`/g;     #Replace correct quotation mark for LaTeX;
    $_ =~ s/\s+\"/ \`\`/g;   #Replace correct quotation mark for LaTeX;
    $_ =~ s/\"\s/\'\' /g;    #Replace correct quotation mark for LaTeX;
    $_ =~ s/\"\:/\'\':/g;    #Replace correct quotation mark for LaTeX;
    $_ =~ s/\"\./\'\'./g;    #Replace correct quotation mark for LaTeX;
    $_ =~ s/\.\"/\'\'/g;     #Replace correct quotation mark for LaTeX;
    $_ =~ s/\"\,/\'\',/g;    #Replace correct quotation mark for LaTeX;
    $_ =~ s/\,\"/\'\'/g;     #Replace correct quotation mark for LaTeX;
    $_ =~ s/\"\;/\'\';/g;    #Replace correct quotation mark for LaTeX;
    $_ =~ s/\;\"/\'\'/g;     #Replace correct quotation mark for LaTeX;
    $_ =~ s/\"\!/\'\'!/g;    #Replace correct quotation mark for LaTeX;
    $_ =~ s/\"\?/\'\'?/g;    #Replace correct quotation mark for LaTeX;
    $_ =~ s/\"\-\-/\'\'--/g; #Replace correct quotation mark for LaTeX;

    $_ =~ s/\s+\.\s+\.\s+\.\s+/\$\\ldots\$ /g; #Replace triple dots for LaTeX;

    $_ =~ s/Africa/{A}frica/g; #Replace for LaTeX;
    $_ =~ s/America/{A}merica/g; #Replace for LaTeX;
    $_ =~ s/Asia/{A}sia/g; #Replace for LaTeX;
    $_ =~ s/Australia/{A}ustralia/g; #Replace for LaTeX;
    $_ =~ s/Europe/{E}urope/g; #Replace for LaTeX;
    $_ =~ s/Carribean/{C}arribean/g; #Replace for LaTeX;
    $_ =~ s/Latin/{L}atin/g; #Replace for LaTeX;
    $_ =~ s/Atlantic/{A}tlantic/g; #Replace for LaTeX;
    $_ =~ s/Pacific/{P}acific/g; #Replace for LaTeX;
    $_ =~ s/Indian/{I}ndian/g; #Replace for LaTeX;
    $_ =~ s/Baltic/{B}altic/g; #Replace for LaTeX;
    $_ =~ s/Sahara/{S}ahara/g; #Replace for LaTeX;
    $_ =~ s/EU/{EU}/g; #Replace for LaTeX;
    $_ =~ s/NAFTA/{NAFTA}/g; #Replace for LaTeX;
    $_ =~ s/MERCOSUL/{MERCOSUL}/g; #Replace for LaTeX;
    $_ =~ s/MERCOSUR/{MERCOSUR}/g; #Replace for LaTeX;
    $_ =~ s/NATO/{NATO}/g; #Replace for LaTeX;
    $_ =~ s/United\s+Nations/{U}nited {N}ations/g; #Replace for LaTeX;
    $_ =~ s/North/{N}orth/g; #Replace for LaTeX;
    $_ =~ s/South/{S}outh/g; #Replace for LaTeX;
    $_ =~ s/West/{W}est/g; #Replace for LaTeX;
    $_ =~ s/East/{E}ast/g; #Replace for LaTeX;

    $_ =~ s/Argentin/{A}rgentin/g; #Replace for LaTeX;
    $_ =~ s/Austria/{A}ustria/g; #Replace for LaTeX;
    $_ =~ s/Brazil/{B}razil/g; #Replace for LaTeX;
    $_ =~ s/British/{B}ritish/g; #Replace for LaTeX;
    $_ =~ s/Bulgaria/{B}ulgaria/g; #Replace for LaTeX;
    $_ =~ s/Canad/{C}anad/g; #Replace for LaTeX;
    $_ =~ s/Colombia/{C}olombia/g; #Replace for LaTeX;
    $_ =~ s/Costa\s+Rica/{C}osta {R}ica/g; #Replace for LaTeX;
    $_ =~ s/Chile/{C}hile/g; #Replace for LaTeX;
    $_ =~ s/Chinese/{C}hinese/g; #Replace for LaTeX;
    $_ =~ s/China/{C}hina/g; #Replace for LaTeX;
    $_ =~ s/Cuba/{C}uba/g; #Replace for LaTeX;
    $_ =~ s/Danish/{D}anish/g; #Replace for LaTeX;
    $_ =~ s/Denmark/{D}enmark/g; #Replace for LaTeX;
    $_ =~ s/Dutch/{D}utch/g; #Replace for LaTeX;
    $_ =~ s/Egypt/{E}gypt/g; #Replace for LaTeX;
    $_ =~ s/English/{E}nglish/g; #Replace for LaTeX;
    $_ =~ s/England/{E}ngland/g; #Replace for LaTeX;
    $_ =~ s/French/{F}rench/g; #Replace for LaTeX;
    $_ =~ s/France/{F}rance/g; #Replace for LaTeX;
    $_ =~ s/Finland/{F}inland/g; #Replace for LaTeX;
    $_ =~ s/Finnish/{F}innish/g; #Replace for LaTeX;
    $_ =~ s/German/{G}erman/g; #Replace for LaTeX;
    $_ =~ s/Great Britain/{G}reat {B}ritain/g; #Replace for LaTeX;
    $_ =~ s/Hebrew/{H}ebrew/g; #Replace for LaTeX;
    $_ =~ s/Holland/{H}olland/g; #Replace for LaTeX;
    $_ =~ s/India/{I}ndia/g; #Replace for LaTeX;
    $_ =~ s/Irish/{I}rish/g; #Replace for LaTeX;
    $_ =~ s/Ireland/{I}reland/g; #Replace for LaTeX;
    $_ =~ s/Israel/{I}srael/g; #Replace for LaTeX;
    $_ =~ s/Italian/{I}talian/g; #Replace for LaTeX;
    $_ =~ s/Italy/{I}taly/g; #Replace for LaTeX;
    $_ =~ s/Japan/{J}apan/g; #Replace for LaTeX;
    $_ =~ s/Jew/{J}ew/g; #Replace for LaTeX;
    $_ =~ s/Korea/{K}orea/g; #Replace for LaTeX;
    $_ =~ s/Mexic/{M}exic/g; #Replace for LaTeX;
    $_ =~ s/Morocc/{M}orocc/g; #Replace for LaTeX;
    $_ =~ s/Netherlands/{N}etherlands/g; #Replace for LaTeX;
    $_ =~ s/Niger/{N}iger/g; #Replace for LaTeX;
    $_ =~ s/Norwegian/{N}orwegian/g; #Replace for LaTeX;
    $_ =~ s/Norway/{N}orway/g; #Replace for LaTeX;
    $_ =~ s/Poland/{P}oland/g; #Replace for LaTeX;
    $_ =~ s/Portug/{P}ortug/g; #Replace for LaTeX;
    $_ =~ s/Russia/{R}ussia/g; #Replace for LaTeX;
    $_ =~ s/Scottish/{S}cottish/g; #Replace for LaTeX;
    $_ =~ s/Scotland/{S}cotland/g; #Replace for LaTeX;
    $_ =~ s/Spaniard/{S}paniard/g; #Replace for LaTeX;
    $_ =~ s/Spanish/{S}panish/g; #Replace for LaTeX;
    $_ =~ s/Spain/{S}pain/g; #Replace for LaTeX;
    $_ =~ s/Swedish/{S}wedish/g; #Replace for LaTeX;
    $_ =~ s/Swede/{S}wede/g; #Replace for LaTeX;
    $_ =~ s/Taiwan/{T}aiwan/g; #Replace for LaTeX;
    $_ =~ s/Tunisia/{T}unisia/g; #Replace for LaTeX;
    $_ =~ s/UK/{UK}/g; #Replace UK for LaTeX;
    $_ =~ s/U\.K\./{UK}/g; #Replace UK for LaTeX;
    $_ =~ s/United States/{U}nited {S}tates/g; #Replace US for LaTeX;
    $_ =~ s/US/{US}/g; #Replace US for LaTeX;
    $_ =~ s/U\.S\./{US}/g; #Replace U.S. for LaTeX;
    $_ =~ s/Venezuela/{V}enezuela/g; #Replace for LaTeX;

    $_ =~ s/Calif\./{CA}/g;
    $_ =~ s/Conn\./{CT}/g;
    $_ =~ s/D\.C\./{DC}/g;
    $_ =~ s/\s+DC/ {DC}/g;
    $_ =~ s/Mass\./{MA}/g;
    $_ =~ s/Md\./{MD}/g;
    $_ =~ s/Mich\./{MI}/g;
    $_ =~ s/N\.C\./{NC}/g;
    $_ =~ s/N\.D\./{ND}/g;
    $_ =~ s/N\.H\./{NH}/g;
    $_ =~ s/N\.J\./{NJ}/g;
    $_ =~ s/N\.M\./{NM}/g;
    $_ =~ s/N\.Y\./{NY}/g;
    $_ =~ s/Pa\./{PA}/g;
    $_ =~ s/R\.I\./{RI}/g;
    $_ =~ s/S\.C\./{SC}/g;
    $_ =~ s/S\.D\./{SD}/g;
    $_ =~ s/Va\./{VA}/g;
    $_ =~ s/Vt\./{VT}/g;
    $_ =~ s/W\.V\./{WV}/g;
    $_ =~ s/Wisc\./{WI}/g;

    $_ =~ s/CPI/{CPI}/g;     #Replace CPI for LaTeX;
    $_ =~ s/PPI/{PPI}/g;     #Replace PPI for LaTeX;
    $_ =~ s/WPI/{WPI}/g;     #Replace WPI for LaTeX;
    $_ =~ s/GDP/{GDP}/g;     #Replace GDP for LaTeX;
    $_ =~ s/GNP/{GNP}/g;     #Replace GNP for LaTeX;
    $_ =~ s/NBER/{NBER}/g;   #Replace capital letters for LaTeX and abbreviate;
    $_ =~ s/National Bureau of Economic Research/{NBER}/g; #Replace for convenience, and mark capital letters for LaTeX and abbreviate;
    $_ =~ s/CEPR/{CEPR}/g;   #Replace capital letters for LaTeX and abbreviate;
    $_ =~ s/Centre for Economic Policy Research/{CEPR}/g; #Replace for convenience, and mark capital letters for LaTeX and abbreviate;
    $_ =~ s/Keynes/{K}eynes/g;
    $_ =~ s/Ramsey/{R}amsey/g;
    $_ =~ s/Schumpeter/{S}chumpeter/g;

    # Replaces roman volume numbering. Should not replace page numbers since these are comma separated
    $_ =~ s/\s+II\./ 2./g;
    $_ =~ s/\s+III\./ 3./g;
    $_ =~ s/\s+IV\./ 4./g;
    $_ =~ s/\s+V\./ 5./g;
    $_ =~ s/\s+VI\./ 6./g;
    $_ =~ s/\s+VII\./ 7./g;
    $_ =~ s/\s+VIII\./ 8./g;
    $_ =~ s/\s+IX\./ 9./g;
    $_ =~ s/\s+X\./ 10./g;
    $_ =~ s/\s+XI\./ 11./g;
    $_ =~ s/\s+XII\./ 12./g;
    $_ =~ s/\s+ii\./ 2./g;
    $_ =~ s/\s+iii\./ 3\./g;
    $_ =~ s/\s+iv\./ 4./g;
    $_ =~ s/\s+v\./ 5./g;
    $_ =~ s/\s+vi\./ 6./g;
    $_ =~ s/\s+vii\./ 7./g;
    $_ =~ s/\s+viii\./ 8./g;
    $_ =~ s/\s+ix\./ 9./g;
    $_ =~ s/\s+x\./ 10./g;
    $_ =~ s/\s+xi\./ 11./g;
    $_ =~ s/\s+xii\./ 12./g;

    # Avoid confusion when entries contain "St. "
    $_ =~ s/\s+St\.\s+/ StXXX /g;  # will be reset later
       
      if(/TI:/){$count++; 
                $line=$_; $line =~ s/TI:(\s+)// ; $line =~ s/\n// ; $line =~ s/  / /g ; 
                $line =~ s/\[/``/g ; $line =~ s/\]/''/g ; # $line =~ s/\.\b//g ; 
                @TI[$count]= $line ; } 
      if(/AU:/){$line=$_; $line =~ s/AU:(\s+)// ; $line =~ s/\n// ; $line =~ s/-/ /g; 
                $line =~ s/;/ and/g; 
                $line =~ s/\,\s+et\s+al\./ etXal/; $line =~ s/\s+et\s+al\./ etXal/;
                $line =~ s/\,\s+et\s+al/ etXal/;   $line =~ s/\s+et\s+al/ etXal/;
                @AU[$count]= $line ; }
    # if(/AF:/){$line=$_; $line =~ s/AF:(\s+)// ; $line =~ s/\n// ; @AF[$count]= $line ; }
      if(/SO:/){$line=$_; $line =~ s/SO:(\s+)// ; $line =~ s/\n// ; @SO[$count]= $line ; }
      if(/PB:/){$line=$_; $line =~ s/PB:(\s+)// ; $line =~ s/\n// ; @PB[$count]= $line ; }
      if(/FTXT:/){$line=$_; $line =~ s/FTXT:(\s+)// ; $line =~ s/\n// ; @FT[$count]= $line ; }
      if(/DT:/){$line=$_; $line =~ s/DT:(\s+)// ; $line =~ s/\n// ; @DT[$count]= $line ; $noprbdt++ ; }
      if(/PY:/){$line=$_; $line =~ s/PY:(\s+)// ; $line =~ s/\n// ; @PY[$count]= $line ; }
      if(/DE:/){$line=$_; $line =~ s/DE:(\s+)// ; $line =~ s/\n// ; $line =~ s/-/ /g; $line =~ s/;/ and/g; @DE[$count]= $line ; }
    # if(/GE:/){$line=$_; $line =~ s/GE:(\s+)// ; $line =~ s/\n// ; @GE[$count]= $line ; }
      if(/AB:/){$line=$_; $line =~ s/AB:(\s+)// ; $line =~ s/\n// ; $line =~ s/  / /g; @AB[$count]= $line ; }
    # if(/AI:/){$line=$_; $line =~ s/AI:(\s+)// ; $line =~ s/\n// ; @AI[$count]= $line ; }
    # if(/UD:/){$line=$_; $line =~ s/UD:(\s+)// ; $line =~ s/\n// ; @UD[$count]= $line ; }
      if(/AV:/){$line=$_; $line =~ s/AV:(\s+)// ; $line =~ s/\n// ; @AV[$count]= $line ; }
    # if(/PR:/){$line=$_; $line =~ s/PR:(\s+)// ; $line =~ s/\n// ; @PR[$count]= $line ; }
    # if(/CR:/){$line=$_; $line =~ s/CR:(\s+)// ; $line =~ s/\n// ; @CR[$count]= $line ; }
    # if(/IS:/){$line=$_; $line =~ s/IS:(\s+)// ; $line =~ s/\n// ; @IS[$count]= $line ; }
      if(/IB:/){$line=$_; $line =~ s/IB:(\s+)// ; $line =~ s/\.// ; $line =~ s/\n// ; @IB[$count]= $line ; }
    # if(/AN:/){$line=$_; $line =~ s/AN:(\s+)// ; $line =~ s/\n// ; @AN[$count]= $line ; }

} # End while loop for read-in

print OUT '% Please note: '. "\n" ;
print OUT '% * Author= or editor= names containing prefixes such as "de", "van", "von", "Jr.", and the like, may need to be adjusted manually using curly brackets.'. "\n" ;
print OUT '%   Please check all INCOLLECTION entries manually. Treatment maybe incomplete due to variation in WebSpirs data.'. "\n" ;
print OUT '% * In particular, you may want to check for subtitles in INCOLLECTION entries. WebSpirs does not allow to distinguish between series and subtitles.'. "\n" ;
print OUT '% * BibTeX does not allow both a volume and a number for a BOOK or an INCOLLECTION item. Choose option [-v] to select'. "\n" ;
print OUT '%   In addition, when books were published in a series, WebSpirs may have erroneously interchanged numbers and volumes, please check.'. "\n" ;
print OUT '% * The keywords= entry only contains JEL numbers (if available). Different classification systems are ignored.'. "\n" ;
print OUT '% * Book-Reviews are suppressed'. "\n" ;
#print OUT '%Please pay close attention to the following In-Collection entries: (some WebSpirs data may have been too different from common patterns to be parsed properly)'. "\n" ; 

for(my $i=1;$i<=$count;$i++){  # Data preparation loops
                               # print OUT "$i\:". @DT[$i] ."  "; # records entries on which some evaluation was performed
    if(@PB[$i] =~ s/\,*\s+([\d+\w+]+st)\s+[eE]dition\s*// || @PB[$i] =~ s/\,*\s+([\d+\w+]+nd)\s+[eE]dition\s*// || @PB[$i] =~ s/\,*\s+([\d+\w+]+rd)\s+[eE]dition\s*// || @PB[$i] =~ s/\,*\s+([\d+\w+]+th)\s+[eE]dition\s*//){
              # print OUT "Got an item with recorded edition number. $i\:". @PB[$i] ." \n";
              @EN[$i]= $1;
              @EN[$i]=~ tr/A-Z/a-z/;
              }
    if(@SO[$i] =~ s/\,*\s+([\d+\w+]+st)\s+[eE]dition\s*// || @SO[$i] =~ s/\,*\s+([\d+\w+]+nd)\s+[eE]dition\s*// || @SO[$i] =~ s/\,*\s+([\d+\w+]+rd)\s+[eE]dition\s*// || @SO[$i] =~ s/\,*\s+([\d+\w+]+th)\s+[eE]dition\s*//){
              # print OUT "Got an item with recorded edition number. $i\:". @SO[$i] ." \n";
              @EN[$i]= $1;
              @EN[$i]=~ tr/A-Z/a-z/;
              }
    # @RM[$i]= @EN[$i];   # Use this line to display edition entry
    if(@DT[$i] =~ m/Journal-Article/){
              # print OUT "Got an ARTICLE item. $i\:". @SO[$i] ." \n";
              $_ = @SO[$i];  # structure like "Northern-Journal. 2000; 14(2-3): 147-55"
                             # or             "Journal. July 1998; 2(3): 26-27"
              $_ =~ s/([\w\-\{\}\:\']+)\.\s+//;
              $jo = $1; $jo =~ s/-/ /g; $jo =~ s/\{//g; $jo =~ s/\}//g; 
              @JO[$i]= $jo;    
              $_ =~ s/\s*@PY[$i]-*\d*\;\s+([\d\-\/]+)\(([\d\-\/]+)\)\:\s+(F*S*C*\d+-\d+)//;
              @VO[$i]= $1; 
              @NO[$i]= $2; 
              @PG[$i]= $3; 
              if(@VO[$i] =~ s/^0$/@NO[$i]/){@NO[$i]= ""}
              @NO[$i] =~ s/^0$//;
              $_ =~ s/Jan\./Jan/; $_ =~ s/Feb\./Feb/; $_ =~ s/Mar\./Mar/; $_ =~ s/Apr\./Apr/; $_ =~ s/Jun\./June/; $_ =~ s/Jul\./July/;
              $_ =~ s/Aug\./Aug/; $_ =~ s/Sept\./Sept/; $_ =~ s/Oct\./Oct/; $_ =~ s/Nov\./Nov/; $_ =~ s/Dec\./Dec/; 
              if($_ =~ s/\,*\s*([1-4a-zA-Z\-\s]+)$//){ @MO[$i]= $1 }
              # Special Issue, part 2, Suppl., etc.
              $_ =~ s/[\,\.\s]+$//g;
                             # Structure is like "Journal. Special Issue, 1988; 9(0): 105-20"
                             # Structure is like "Journal. Suppl. 1 1996; 10(0): 1-14"
                             # Structure is like "Journal. Part 2, July 1980; 53(3): 13-29"
              @RM[$i] = $_;  # Remainder of SO: string go to note={}
              if(@FT[$i] =~ m/GOTO\(/){ $_ = @FT[$i]; /GOTO\(\d+\,([\w\S\.\:\/\~\&\?+]+)\)/; @SO[$i] = $1; }
                 else                 { $_ = @AV[$i]; @SO[$i] = @AV[$i]; } 
              $kw = @DE[$i]; $kw =~ s/\(\d+\) //g; $kw =~ s/ \(\d+\)//g; @KW[$i] = $kw; 
              if(@JO[$i] !~ m/\w+/ || @VO[$i] !~ m/\w+/ || @PG[$i] !~ m/\d+/ || (@PG[$i]==@NO[$i] && @MO[$i]==@VO[$i]) || @MO[$i] =~ m/0/ || @MO[$i] =~ m/5-9/ ){
                $probljo++;
                if($probljo==1){ print OUT "\n" .'%ARTICLE entries may be incomplete or wrong. Please check manually. (This problem can be due to a non-standard entry in WebSpirs.)'. "\n" ; warn 'There were @ARTICLE entries with problems. See head of output file for details.'. "\n". 'Error occured';}
                print OUT "\%$i\: @AU[$i], @TI[$i] \n";
                }
    }
    elsif(@DT[$i] =~ m/Working-Paper/){
              # print OUT "Got an ARTICLE (Working-Paper) item. $i\:". @SO[$i] ." \n";
              $_ = @PB[$i];  # structure is like "PB:  National Bureau of Economic Research Working Paper: 7440 December 1999; 13"
              /([a-zA-Z\,\s\{\}\.]+)\:\s+([a-zA-Z0-9\/\-]+)\s+(\w+)\s+(\d+)/;
              @JO[$i]= $1; 
              @VO[$i]= $2;
              @MO[$i]= $3;    
              @PY[$i]= $4; 
              if(@JO[$i] !~ m/\w+/){
                $_ = @PB[$i];  # structure is like "PB:  Centre for the Study of African Economies Working Paper: WPS/00/07 2000; 30"
                /([a-zA-Z\,\s\{\}\.]+)\:\s+([a-zA-Z0-9\/\-]+)\s+(\d+)/;
                @JO[$i]= $1;
                @VO[$i]= $2;
                @MO[$i]= "";    
                @PY[$i]= $3; 
                }
              if(@JO[$i] !~ m/\w+/){
                $_ = @PB[$i];  # structure was NOT like "PB:  National Bureau of Economic Research Working Paper: 7440 December 1999; 13"
                               # try alternatives; one is given below, further alternatives may be needed
                /([a-zA-Z\,\s\{\}\.]+)(\.*)\s+([a-zA-Z0-9\/\-]+)\s+(\w+)\s+(\d+)/;
                @JO[$i]= $1;
                @VO[$i]= $2;
                @MO[$i]= $3;    
                @PY[$i]= $4; 
                }
              $jo= @JO[$i]; $jo =~ s/\,//g; $jo =~ s/ Series//g; $jo =~ s/ Papers/ Paper/g; $jo =~ s/ papers/ paper/g; @JO[$i]=$jo;
              $vo= @VO[$i]; $vo =~ s/[a-zA-Z]+\///g; $vo =~ s/[a-zA-Z]+\-//g; @VO[$i] = $vo; $vo = "";
              if(@FT[$i] =~ m/GOTO\(/){ $_ = @FT[$i]; /GOTO\(\d+\,([\w\S\.\:\/\~\&\?+]+)\)/; @SO[$i] = $1; }
                 else                 { $_ = @AV[$i]; @SO[$i] = @AV[$i]; } 
              $sr = @SO[$i]; $sr =~ s/Copies available from\:\s//g; $sr =~ s/\{//g; $sr =~ s/\}//g; @SO[$i] = $sr ;
              $kw = @DE[$i]; $kw =~ s/\(\d+\) //g; $kw =~ s/ \(\d+\)//g; @KW[$i] = $kw; 
              if($option !~ m/\-t/ && @JO[$i] !~ m/paper/ && @JO[$i] !~ m/Paper/ ){
                    @JO[$i] = @JO[$i] . ' Working Paper'}
              if(@JO[$i] !~ m/\w+/ || @VO[$i] !~ m/\w+/){
                $problwp++;
                if($problwp==1){ print OUT "\n" .'%ARTICLE (Working-Paper) entries may be incomplete. Please check manually. (This problem can be due to a non-standard entry in WebSpirs.)'. "\n" ; warn 'There were @ARTICLE (Working-Paper) entries with problems. See head of output file for details.'. "\n". 'Error occured';}
                print OUT "\%$i\: @AU[$i], @TI[$i] \n";
                }
    }
    elsif(@DT[$i] =~ m/Book/ && @DT[$i] !~ m/Book-Review/){
              # print OUT "Got a BOOK. $i\:". @SO[$i] ."  ";
              $_ = @PB[$i];  
              $_ =~ s/\s+/ /g;   # Remove double spaces
              $_ =~ s/\.\./\./g; # Remove double dots
              $_ =~ s/\.\s+[pP]reviously\s+[pP]ublished\:\s+\d+\.$//; # . Previously published: 1999.
              $_ =~ s/[vV]ol[umes]*\.*\s+([\d+\-]+)/VOL $1/g;
              $_ =~ s/[nN]o[s]*\.*\s+([\d+\-]+)/NUM $1/g;
              $_ =~ s/[nN]um[bers]*\.*\s+([\d+\-]+)/NUM $1/g;
              $_ =~ s/VOL\s+(\d+)\s+([a-zA-Z0-9\,\s\{\}\-\'\`]+)/VOL $1. $2/;
              $_ =~ s/NUM\s+(\d+)\s+([a-zA-Z0-9\,\s\{\}\-\'\`]+)/NUM $1. $2/;
              $_ =~ s/\;\s+[mclxvi\,\s]*[\d\-]+$//; # remove page numbers from string end
              $_ =~ s/\s+([A-Z])\.\s+/ $1 /;  $_ =~ s/\s+([A-Z])\.\s+/ $1 /;  $_ =~ s/\s+([A-Z])\.\s+/ $1 /; # remove dots from capital letter middle names
              $_ =~ s/\,\s+@PY[$i]$//; $_ =~ s/\;\s+@PY[$i]$//; $_ =~ s/\s+@PY[$i]$//; $_ =~ s/\.\s+@PY[$i]$//; 
              $_ =~ s/\;\s+[dD]istrib[\.uted]*\s+[a-zA-Z0-9\,\s\{\}\-\'\`]*by\s+([a-zA-Z0-9\,\s\{\}\-\'\`]+)//; @SO[$i] = $1;  # turn distributor into source
              $_ =~ s/[tT]ranslat[edion]*\s+[a-zA-Z0-9\,\s\{\}\-\'\`]*\.\s*//;
              $_ =~ s/[fF]oreword\s+by\s+[a-zA-Z0-9\,\s\{\}\-\'\`]*\.\s*//;
              # Chop off wrongly positioned festschrift type entries. Structure is like "PB:  Boulder and Oxford: Preferences, uncertainty, and optimality:  Essays in honor  of Leonid Hurwicz.  Westview Press 1990"
              if ($_ =~ s/\s+([a-zA-Z0-9\,\s\{\}\-\'\`]+\:\s+[a-zA-Z0-9\,\s\{\}\-\'\`]*[hH]onou*r[ing]*\s+[a-zA-Z0-9\,\s\{\}\-\'\`]+)\.// || 
                  $_ =~ s/\s+([a-zA-Z0-9\,\s\{\}\-\'\`]+\:\s+[a-zA-Z0-9\,\s\{\}\-\'\`]*[fF]estschrift\s+[a-zA-Z0-9\,\s\{\}\-\'\`]+)\.//){
                  @BT[$i]= $1;
                  }
              $_ =~ s/\;\s+in\s+association\s+with\s+[a-zA-Z0-9\,\s\{\}\-\'\`]//; # string like "; in association with International Economic Association" chopped off
              # @RM[$i]= $_;   # Use this line to display PB:

              # Distibutor, year and pages are chopped off. Treat remaining string:
              # Alternative 1: Structure is like "PB:  World Bank Discussion Papers, no. 97 Washington, D.C.: World Bank"
              if($_ =~ m/([a-zA-Z0-9\,\s\{\}\(\)\-]+\s+[pP]apers)\,\s+[a-zA-Z0-9\,\s\{\}\(\)\-]+/){ # Perform correction
                $_ =~ s/NUM\s+([\d+\-\/]+)\s+Washington/NUM $1. Washington/;
                }
              # Alternative 2: Double publisher; use first only
              # Structure is like "International Political Economy Series. New York: St. Martin's Press; London: Macmillan Press, 1996; xii, 185"
              if($_ =~ s/\s*([a-zA-Z0-9\,\;\s\{\}\-\'\`]+)\:\s+([a-zA-Z\,\s\{\}\-\'\`]+)\;\s+[a-zA-Z0-9\,\;\s\{\}\-\'\`]+\:\s+[a-zA-Z\,\s\{\}\-\'\`]+[\,\s+\d+]*$//){
                @AD[$i]= $1;             
                @PB[$i]= $2;
                }
              # Alternative 3: Single publisher
              # Structure is like "PB:  Cambridge and London: MIT Press for the National Bureau of Economic Research, 2001"
              elsif($_ =~ s/\s*([a-zA-Z0-9\,\;\s\{\}\-\'\`]+)\:\s+([a-zA-Z\,\s\{\}\-\'\`]+)[\,\s+\d+]*$//){
                @AD[$i]= $1;             
                @PB[$i]= $2;
                }
              # @RM[$i]= $_;   # Use this line to display remainder of PB:

              # Publisher and address are chopped off. Treat remaining string:
              # Alternative 4: Structure parallel zu Collective-Volume-Article
              if($_ =~ s/([a-zA-Z0-9\,\s\{\}\(\)\-]+\s+[sS]eries)[\.\:]\s+[a-zA-Z0-9\,\s\{\}\(\)\-]+//){ # Series entry
                  @SE[$i]= $1;
                  }
              if($_ =~ s/([a-zA-Z0-9\,\s\{\}\(\)\-]+\s+[aA]nnual)[\.\:]\s+[a-zA-Z0-9\,\?\s\{\}\(\)\-\'\`]+//){ # Series entry and simple booktitle
                  @SE[$i]= $1;
                  }
              # Alternative 5: Structure parallel zu Collective-Volume-Article
              if($_ =~ s/([sS]pecial\s+[iI]ssue\s+[a-zA-Z0-9\d\,\s\{\}\(\)\-]+)\.\s+[a-zA-Z0-9\,\s\{\}\(\)\-]+//){ # Special issue
                  @SE[$i]= $1;
                  }
              # Further treatments of SE follow below
              # Alternative 6: Structure is like "PB:  Europe in Transition: NYU European Studies Series. Houndmills, U.K. and New York: Palgrave"
              if($_ =~ s/([a-zA-Z0-9\,\s\{\}\(\)\-]+\:\s+[a-zA-Z0-9\,\s\{\}\(\)\-]+\s+[sS]eries)//){ # Separated series entry
                  @SE[$i]= $1;
                  }
              # Alternative 7: Structure is like "PB:  With an introduction by Carl Shapiro and Hal R Varian. European Communication Council Report series. Heidelberg and New York: Springer, 2000"
              if($_ =~ s/\.\s+([a-zA-Z0-9\,\s\{\}\(\)\-]+\s+[sS]eries)//){ # Different series entry (after foreword/introduction)
                  @SE[$i]= $1;
                  }
              # Alternative 8: Structure is like "PB:   With an introduction by Carl Shapiro and Hal R. Varian. Ford Foundation Series on Asset Building. New York: Russell Sage Foundation"
              if($_ =~ s/\.\s+([\w\s\{\}\(\)\-]+\s+[sS]eries\s+[\w\s\{\}\(\)\-]+)//){ # Different series entry
                  @SE[$i]= $1;
                  }
              # Alternative 9: Structure is like "PB:  Ford Foundation Series on Asset Building. New York: Russell Sage Foundation"
              if($_ =~ s/([\w\s\{\}\(\)\-]+\s+[sS]eries\s+[\w\s\{\}\(\)\-]+)//){ # Different series entry
                  @SE[$i]= $1;
                  }
              # Alternative 10: Structure is like "PB:  Harvard Business Review Book Series. Boston: Harvard Business School Press"
              if($_ =~ s/([a-zA-Z0-9\,\s\{\}\(\)\-]+\s+[sS]eries)//){ # Simple series entry
                  @SE[$i]= $1;
                  }
              # @RM[$i]= $_;   # Use this line to display remainder of PB:
              if($SE[$i] !~ m/\w/){ @SE[$i] = $_ }
              # @RM[$i]= @SE[$i];   # Use this line to display @SE[$i] before further treatment

              @AD[$i] =~ s/\; /, /g;
              @SE[$i] =~ s/\.\. /. /g; @SE[$i] =~ s/\s\s/ /g;
              if(@SE[$i] =~ m/Paperback/){@SE[$i]=""}
              if(@SE[$i] =~ m/paperback/){@SE[$i]=""}
              if(@SE[$i] =~ m/Revised edition/){@SE[$i]=""}
              if(@SE[$i] =~ m/revised edition/){@SE[$i]=""}
              if(@SE[$i] =~ s/([hH]andbooks*\s+[a-zA-Z\s\{\}]+)\,\s+NUM\s+([\d\-]+)\s+([a-zA-Z\s\{\}\-\'\`]+)//){
                        @SE[$i] = $1;
                        @NO[$i] = $2;
                        @BT[$i] = $3;
                        }
              elsif(@SE[$i] =~ m/VOL\s+([\d\-]+)\,\s+NUM\s+([\d\-]+)/){
                        $_ = @SE[$i];
                        /VOL\s+([\d\-]+)\,\s+NUM\s+([\d\-]+)/;
                        @VO[$i] = $1;
                        @NO[$i] = $2;
                        /([a-zA-Z0-9\,\s\{\}\.\;\-]+)[\,\.]*\s+VOL\s+[\d\-]+/;
                        @SE[$i] = $1;
                        # print OUT 'Got a volume/number entry at '. "$i @AU[$i] \n";
                        }
              elsif(@SE[$i] =~ m/\s+NUM\s+([\d\-]+)/){
                        $_ = @SE[$i];
                        /\s+NUM\s+([\d\-]+)/;
                        @NO[$i] = $1;
                        /([a-zA-Z0-9\,\s\{\}\.\;\-]+)[\,\.]*\s+NUM\s+[\d\-]+/;
                        @SE[$i] = $1;
                        # print OUT 'Got a number entry at '. "$i @AU[$i] \n";
                        }
              elsif(@SE[$i] =~ m/\s+[bB]ook\s+([\d\-]+)/){
                        $_ = @SE[$i];
                        /\s+[bB]ook\s+([\d\-]+)/;
                        @NO[$i] = $1;
                        /([a-zA-Z0-9\,\s\{\}\.\;\-]+)[\,\.]*\s+[bB]ook\s+[\d\-]+/;
                        @SE[$i]= $1;
                        # print OUT 'Got a book-number entry at '. "$i @AU[$i] \n";
                        }
              elsif(@SE[$i] =~ m/\s+[pP]art\s+([\d\-]+)/){
                        $_ = @SE[$i];
                        /\s+[pP]art\s+([\d\-]+)/;
                        @NO[$i] = $1;
                        /([a-zA-Z0-9\,\s\{\}\.\;\-]+)[\,\.]*\s+[pP]art\s+[\d\-]+/;
                        @SE[$i]= $1;
                        # print OUT 'Got a part-number entry at '. "$i @AU[$i] \n";
                        }
              elsif(@SE[$i] =~ m/\s+VOL\s+([\d\-]+)/){
                        $_ = @SE[$i];
                        /\s+VOL\s+([\d\-]+)/;
                        @VO[$i] = $1;
                        /([a-zA-Z0-9\,\s\{\}\.\;\-]+)[\,\.]*\s+VOL\s+[\d\-]+/;
                        @SE[$i]= $1;
                        # print OUT 'Got a volume entry at '. "$i @AU[$i] \n";
                        }
              if(@TI[$i] =~ s/[\,\;\.]*\s*Volume[s]*\s+([\d\-]+)//){
                        @VOTMP[$i] = $1;
                        if(@VO[$i] =~ m/\d+/ && @NO[$i] !~ m/d+/){@NO[$i]= @VOTMP[$i]; }
                        else {@VO[$i]= @NO[$i]; @NO[$i]= @VOTMP[$i]; }
                        # print OUT 'Got a volume entry (from title) at '. "$i \n";
                        }
              $se = @SE[$i]; $se =~ s/Volume\s+//g; $se =~ s/volume\s+//g; $se =~ s/Vol\.\s+//g; $se =~ s/vol\.\s+//g; 
                             $se =~ s/Number\s+//g; $se =~ s/number\s+//g; $se =~ s/No\.\s+//g; $se =~ s/no\.\s+//g; 
                             if($se !~ m/([a-zA-Z]+)/){@SE[$i] = ""; }  # remove series if only Volume, etc. contained
              # (source is publisher/distributor) if(@FT[$i] =~ m/GOTO\(/){ $_ = @FT[$i]; /GOTO\(\d+\,([\w\S\.\:\/\~\&\?+]+)\)/; @SO[$i] = $1; }
              # else                 { $_ = @AV[$i]; @SO[$i] = @AV[$i]; } 
              @SE[$i] =~ s/\s+([A-Z])\s+/ $1. /g; @SE[$i] =~ s/^([A-Z])\s+/$1. /; # add back dots to capital letter first or middle names
              @PB[$i] =~ s/\s+([A-Z])\s+/ $1. /g; @PB[$i] =~ s/^([A-Z])\s+/$1. /; # add back dots to capital letter first or middle names

              $kw = @DE[$i]; $kw =~ s/\(\d+\) //g; $kw =~ s/ \(\d+\)//g; @KW[$i] = $kw; 
              if(@PB[$i] !~ m/\w+/ || @PB[$i] =~ m/;/ || @AD[$i] !~ m/\w+/ || (@VO[$i] =~ m/\d+/ && @SE[$i] !~ m/\w+/) || (@NO[$i] =~ m/\d+/ && @SE[$i] !~ m/\w+/)){
                $problbk++;
                if($problbk==1){ print OUT "\n" .'%BOOK entries may be incomplete. Please check manually. (This problem can be due to a non-standard entry in WebSpirs.)'. "\n" ; warn 'There were @BOOK entries with problems. See head of output file for details.'. "\n". 'Error occured';}
                print OUT "\%$i\: @AU[$i], @TI[$i] \n";
                }
    }
    elsif(@DT[$i] =~ m/Collective-Volume-Article/){
              # print OUT "Got an INCOLLECTION item. $i\:". @SO[$i] ." \n";
              $_ = @PB[$i];  
              $_ =~ s/\s+/ /g;   # Remove double spaces
              $_ =~ s/\.\./\./g; # Remove double dots
              $_ =~ s/\.\s+[pP]reviously\s+[pP]ublished\:\s+\d+\.$//; # . Previously published: 1999.
              $_ =~ s/[vV]ol[umes]*\.*\s+([\d+\-]+)/VOL $1/g;
              $_ =~ s/[nN]o[s]*\.*\s+([\d+\-]+)/NUM $1/g;
              $_ =~ s/[nN]um[bers]*\.*\s+([\d+\-]+)/NUM $1/g;
              $_ =~ s/VOL\s+(\d+)\s+([a-zA-Z0-9\,\s\{\}\-\'\`]+)/VOL $1. $2/;
              $_ =~ s/NUM\s+(\d+)\s+([a-zA-Z0-9\,\s\{\}\-\'\`]+)/NUM $1. $2/;
              if($_ =~ s/(\s+@PY[$i]$\;\s+[\d\-]+)[\.\s]+([a-zA-Z0-9\,\;\.\s\{\}\-\'\`]+)$//){
                  # Problematic inversion of order in PB: (Booktitle at end of string, structure is like "PB:  Handbooks in Economics series, book 2. Amsterdam; New York and Oxford: North-Holland; distributed in the U.S. and Canada by Elsevier Science, New York 1984; 1396-1457 Handbook of Econometrics.  Volume II.")
                  $_ = $_ . $1;
                  @BT[$i] = $2;
                  }
              $_ =~ s/\;\s+([mclxvi\d\-]+)$//;
              @PG[$i]= $1;
              $_ =~ s/\s+([A-Z])\.\s+/ $1 /;  $_ =~ s/\s+([A-Z])\.\s+/ $1 /;  $_ =~ s/\s+([A-Z])\.\s+/ $1 /; # remove dots from capital letter middle names
              $_ =~ s/\,\s+@PY[$i]$//; $_ =~ s/\;\s+@PY[$i]$//; $_ =~ s/\s+@PY[$i]$//; $_ =~ s/\.\s+@PY[$i]$//; 
              $_ =~ s/\;\s+[dD]istrib[\.uted]*\s+[a-zA-Z0-9\,\s\{\}\-\'\`]*by\s+([a-zA-Z0-9\,\s\{\}\-\'\`]+)//; @SO[$i] = $1;  # turn distributor into source
              $_ =~ s/[tT]ranslat[edion]*\s+[a-zA-Z0-9\,\s\{\}\-\'\`]*\.\s*//;
              $_ =~ s/[fF]oreword\s+by\s+[a-zA-Z0-9\,\s\{\}\-\'\`]*\.\s*//;
              # Chop off wrongly positioned festschrift type entries. Structure is like "PB:  Boulder and Oxford: Preferences, uncertainty, and optimality:  Essays in honor  of Leonid Hurwicz.  Westview Press 1990"
              if ($_ =~ s/\s+([a-zA-Z0-9\,\s\{\}\-\'\`]+\:\s+[a-zA-Z0-9\,\s\{\}\-\'\`]*[hH]onou*r[ing]*\s+[a-zA-Z0-9\,\s\{\}\-\'\`]+)\.// || 
                  $_ =~ s/\s+([a-zA-Z0-9\,\s\{\}\-\'\`]+\:\s+[a-zA-Z0-9\,\s\{\}\-\'\`]*[fF]estschrift\s+[a-zA-Z0-9\,\s\{\}\-\'\`]+)\.//){
                  @BT[$i]= $1;
                  }
              $_ =~ s/\;\s+in\s+association\s+with\s+[a-zA-Z0-9\,\s\{\}\-\'\`]//; # string like "; in association with International Economic Association" chopped off
              # @RM[$i]= $_;   # Use this line to display PB:
              @ED[$i]= "EDITORS TO BE ADDED MANUALLY";

              # Distibutor, year and pages are chopped off. Treat remaining string:
              # Alternative 1: Structure is like "PB:  World Bank Discussion Papers, no. 97 Washington, D.C.: World Bank"
              if($_ =~ m/([a-zA-Z0-9\,\s\{\}\(\)\-]+\s+[pP]apers)\,\s+[a-zA-Z0-9\,\s\{\}\(\)\-]+/){ # Perform correction
                $_ =~ s/NUM\s+([\d+\-\/]+)\s+Washington/NUM $1. Washington/;
                }
              # Alternative 2: Bracketed positioning; address first in string, publisher last in string
              # Structure is like "London and New York: A 'second edition' of The General Theory.  Volume 1.  Routledge"
              if($_ =~ m/(^[a-zA-Z\,\;\s\{\}\-]+)\:\s+([a-zA-Z0-9\,\?\.\:\;\s\{\}\-\'\`]+\.\s+[a-zA-Z\,\s\{\}\-]+)$/){
                @PB[$i]= $2;
                $_ =~ s/(^[a-zA-Z\,\;\s\{\}\-]+)\:\s+//;
                @AD[$i]= $1;
                if($_ =~ s/\.\s+([a-zA-Z\,\s\{\}\-]+)$//){ @PB[$i]= $1 }
                }
              # Alternative 3: Double publisher; use first only
              # Structure is like "International Political Economy Series. New York: St. Martin's Press; London: Macmillan Press, 1996"
              elsif($_ =~ s/\s*([a-zA-Z0-9\,\;\s\{\}\-\'\`]+)\:\s+([a-zA-Z\,\s\{\}\-\'\`]+)\;\s+[a-zA-Z0-9\,\;\s\{\}\-\'\`]+\:\s+[a-zA-Z\,\s\{\}\-\'\`]+[\,\s+\d+]*$//){
                @AD[$i]= $1;             
                @PB[$i]= $2;
                }
              # Alternative 4: Single publisher
              # Structure is like "PB:  Cambridge and London: MIT Press for the National Bureau of Economic Research"
              elsif($_ =~ s/\s*([a-zA-Z0-9\,\;\s\{\}\-\'\`]+)\:\s+([a-zA-Z\,\s\{\}\-\'\`]+)[\,\s+\d+]*$//){
                @AD[$i]= $1;             
                @PB[$i]= $2;
                }
              # @RM[$i]= $_;   # Use this line to display remainder of PB:

              # Publisher and address are chopped off. Treat remaining string:
              # Alternative 5: Structure is like "PB:  Studies in the Modern World Economy, vol. 15. Trade, theory and econometrics: Essays in honor of John S.  Chipman"
              if($_ =~ s/([a-zA-Z0-9\,\s\{\}\(\)\`\'\-]+\,*\s*[NUM]*[VOL]*)\.\s+([a-zA-Z0-9\,\:\?\s\{\}\(\)\-\'\`]+)//){ # Series entry and colon-separated booktitle
                  @SE[$i]= $1;
                  @BT[$i]= $2;
                  }
              # Alternative 6: Structure is like "PB:  NBER Project Report series. Inquiries in the economics of aging"
              if($_ =~ s/([a-zA-Z0-9\,\s\{\}\(\)\`\'\-]+\s+[sS]eries)[\.\:]\s+([a-zA-Z0-9\,\?\s\{\}\(\)\-\'\`]+)//){ # Series entry and simple booktitle
                  @SE[$i]= $1;
                  @BT[$i]= $2;
                  }
              if($_ =~ s/([a-zA-Z0-9\,\s\{\}\(\)\`\'\-]+\s+[aA]nnual)[\.\:]\s+([a-zA-Z0-9\,\?\s\{\}\(\)\-\'\`]+)//){ # Series entry and simple booktitle
                  @SE[$i]= $1;
                  @BT[$i]= $2;
                  }
              # Alternative 7: Structure is like "PB:  Special Issue of Journal of Risk and Uncertainty, Vol. 19, nos. 1-3, 1999. Elicitation of preferences"
              if($_ =~ s/([sS]pecial\s+[iI]ssue\s+[a-zA-Z0-9\d\,\s\{\}\(\)\`\'\-]+)\.\s+([a-zA-Z0-9\,\?\s\{\}\(\)\-\'\`]+)//){ # Special issue
                  @SE[$i]= $1;
                  @BT[$i]= $2;
                  }
              # Further treatments of SE follow below
              # Alternative 8: Structure is like "PB:  Europe in Transition: NYU European Studies Series"
              if($_ =~ s/([a-zA-Z0-9\,\s\{\}\(\)\-]+\:\s+[a-zA-Z0-9\,\s\{\}\(\)\`\'\-]+\s+[sS]eries)//){ # Separated series entry
                  @SE[$i]= $1;
                  }
              # Alternative 9: Structure is like "PB:  With an introduction by Carl Shapiro and Hal R Varian. European Communication Council Report series"
              if($_ =~ s/\.\s+([a-zA-Z0-9\,\s\{\}\(\)\-]+\s+[sS]eries)//){ # Different series entry (after foreword/introduction)
                  @SE[$i]= $1;
                  }
              # Alternative 10: Structure is like "PB:   With an introduction by Carl Shapiro and Hal R. Varian. Ford Foundation Series on Asset Building"
              if($_ =~ s/\.\s+([\w\s\{\}\(\)\-]+\s+[sS]eries\s+[\w\s\{\}\(\)\-]+)//){ # Different series entry
                  @SE[$i]= $1;
                  }
              # Alternative 11: Structure is like "PB:  Ford Foundation Series on Asset Building"
              if($_ =~ s/([\w\s\{\}\(\)\-]+\s+[sS]eries\s+[\w\s\{\}\(\)\-]+)//){ # Different series entry
                  @SE[$i]= $1;
                  }
              # Alternative 12: Structure is like "PB:  Harvard Business Review Book Series"
              if($_ =~ s/([a-zA-Z0-9\,\s\{\}\(\)\-]+\s+[sS]eries)//){ # Simple series entry
                  @SE[$i]= $1;
                  }
              # @RM[$i]= $_;   # Use this line to display remainder of PB:
              if(@SE[$i] !~ m/\w/){ @SE[$i] = $_ }
              # @RM[$i]= @SE[$i];   # Use this line to display @SE[$i] before further treatment

              @AD[$i] =~ s/\; /, /g;
              @SE[$i] =~ s/\.\. /. /g; @SE[$i] =~ s/\s\s/ /g;
              if(@SE[$i] =~ m/Paperback/){@SE[$i]=""}
              if(@SE[$i] =~ m/paperback/){@SE[$i]=""}
              if(@SE[$i] =~ m/Revised edition/){@SE[$i]=""}
              if(@SE[$i] =~ m/revised edition/){@SE[$i]=""}
              if(@SE[$i] =~ s/([hH]andbooks*\s+[a-zA-Z\s\{\}]+)\,\s+NUM\s+([\d\-]+)\s+([a-zA-Z\s\{\}\-\'\`]+)//){
                        @SE[$i] = $1;
                        @NO[$i] = $2;
                        @BT[$i] = $3;
                        }
              elsif(@SE[$i] =~ m/VOL\s+([\d\-]+)\,\s+NUM\s+([\d\-]+)/){
                        $_ = @SE[$i];
                        /VOL\s+([\d\-]+)\,\s+NUM\s+([\d\-]+)/;
                        @VO[$i] = $1;
                        @NO[$i] = $2;
                        /([a-zA-Z0-9\,\s\{\}\.\;\-]+)[\,\.]*\s+VOL\s+[\d\-]+/;
                        @SE[$i]= $1;
                        # print OUT 'Got a volume/number entry at '. "$i @AU[$i] \n";
                        }
              elsif(@SE[$i] =~ m/\s+NUM\s+([\d\-]+)/){
                        $_ = @SE[$i];
                        /\s+NUM\s+([\d\-]+)/;
                        @NO[$i] = $1;
                        /([a-zA-Z0-9\,\s\{\}\.\;\-]+)[\,\.]*\s+NUM\s+[\d\-]+/;
                        @SE[$i]= $1;
                        # print OUT 'Got a number entry at '. "$i @AU[$i] \n";
                        }
              elsif(@SE[$i] =~ m/\s+[bB]ook\s+([\d\-]+)/){
                        $_ = @SE[$i];
                        /\s+[bB]ook\s+([\d\-]+)/;
                        @NO[$i] = $1;
                        /([a-zA-Z0-9\,\s\{\}\.\;\-]+)[\,\.]*\s+[bB]ook\s+[\d\-]+/;
                        @SE[$i]= $1;
                        # print OUT 'Got a book-number entry at '. "$i @AU[$i] \n";
                        }
              elsif(@SE[$i] =~ m/\s+[pP]art\s+([\d\-]+)/){
                        $_ = @SE[$i];
                        /\s+[pP]art\s+([\d\-]+)/;
                        @NO[$i] = $1;
                        /([a-zA-Z0-9\,\s\{\}\.\;\-]+)[\,\.]*\s+[pP]art\s+[\d\-]+/;
                        @SE[$i]= $1;
                        # print OUT 'Got a part-number entry at '. "$i @AU[$i] \n";
                        }
              elsif(@SE[$i] =~ m/\s+VOL\s+([\d\-]+)/){
                        $_ = @SE[$i];
                        /\s+VOL\s+([\d\-]+)/;
                        @VO[$i] = $1;
                        /([a-zA-Z0-9\,\s\{\}\.\;\-]+)[\,\.]*\s+VOL\s+[\d\-]+/;
                        @SE[$i]= $1;
                        # print OUT 'Got a volume entry at '. "$i @AU[$i] \n";
                        }
              if(@BT[$i] =~ m/[\,\;\.]*\s*VOL\s+([\d\-]+)/){
                        @BT[$i] =~ s/[\.\,\;]*\s*VOL\s+([\d\-]+)//; 
                        @VOTMP[$i] = $1;
                        if(@VO[$i] =~ m/\d+/ && @NO[$i] !~ m/d+/){@NO[$i]= @VOTMP[$i]; }
                        else {@VO[$i]= @NO[$i]; @NO[$i]= @VOTMP[$i]; }
                        # print OUT 'Got a volume entry (from book-title) at '. "$i \n";
                        }
              if(@BT[$i] !~ m/\w+/ && @SE[$i] =~ m/\w+/){
                # Treat cases with missing punctuation. 
                # Structure is like "National Bureau of Economic Research Project Report series The economics of aging.  Chicago and London: University of Chicago Press 1989"
                if(@SE[$i] =~ m/([a-zA-Z0-9\,\s\{\}\(\)\-]+\s+[sS]eries)\s+([A-Z]+[a-zA-Z0-9\,\s\{\}\(\)\-]+)/){
                  @SE[$i]= $1;
                  @BT[$i]= $2;
                  }
                if(@SE[$i] =~ m/([a-zA-Z0-9\,\s\{\}\(\)\-]+\s+Research+Annual)\s+([A-Z]+[a-zA-Z0-9\,\s\{\}\(\)\-]+)/){
                  @SE[$i]= $1;
                  @BT[$i]= $2;
                  }
                # Structure is like "National Bureau of Economic Research Conference Report Social Experimentation.  Chicago and London: University of Chicago Press 1985"
                if(@SE[$i] =~ m/([a-zA-Z0-9\,\s\{\}\(\)\-]+\s+[rR]eport[s]*)\s+([A-Z]+[a-zA-Z0-9\,\s\{\}\(\)\-]+)/){
                  @SE[$i]= $1;
                  @BT[$i]= $2;
                  }
                # Structure is like "Second Global Prospects Conference: Background papers Problems of developing countries in the 1990s. General topics"
                 if(@SE[$i] =~ m/([a-zA-Z0-9\,\s\{\}\(\)\-]*[bB]ackground\s+[pP]aper[s]*)\s+([A-Z]+[a-zA-Z0-9\,\s\{\}\(\)\-]+)/){
                  @SE[$i]= $1; 
                  @BT[$i]= $2;
                  @SE[$i] =~ s/^\s//;
                  }
                }
              if(@TI[$i] =~ s/[\,\;\.]*\s*Volume[s]*\s+([\d\-]+)//){
                        @VOTMP[$i] = $1;
                        if(@VO[$i] =~ m/\d+/ && @NO[$i] !~ m/d+/){@NO[$i]= @VOTMP[$i]; }
                        else {@VO[$i]= @NO[$i]; @NO[$i]= @VOTMP[$i]; }
                        # print OUT 'Got a volume entry (from title) at '. "$i \n";
                        }
              $se = @SE[$i]; $se =~ s/Volume\s+//g; $se =~ s/volume\s+//g; $se =~ s/Vol\.\s+//g; $se =~ s/vol\.\s+//g; 
                             $se =~ s/Number\s+//g; $se =~ s/number\s+//g; $se =~ s/No\.\s+//g; $se =~ s/no\.\s+//g; 
                             if($se !~ m/([a-zA-Z]+)/){@SE[$i] = ""; }  # remove series if only Volume, etc. contained
              # (source is publisher/distributor) if(@FT[$i] =~ m/GOTO\(/){ $_ = @FT[$i]; /GOTO\(\d+\,([\w\S\.\:\/\~\&\?+]+)\)/; @SO[$i] = $1; }
              # else                 { $_ = @AV[$i]; @SO[$i] = @AV[$i]; } 
              if(@BT[$i] !~ m/\w+/ && @SE[$i] =~ m/\w+/ && @SE[$i] !~ m/[sS]eries/){
                # If booktitle still empty, make series entry the booktitle
                  @BT[$i]= @SE[$i];
                  @SE[$i]= "";
                }
              @SE[$i] =~ s/\s+([A-Z])\s+/ $1. /g; @SE[$i] =~ s/^([A-Z])\s+/$1. /; # add back dots to capital letter first or middle names
              @BT[$i] =~ s/\s+([A-Z])\s+/ $1. /g; @BT[$i] =~ s/^([B-Z])\s+/$1. /; # add back dots to capital letter first or middle names
              @PB[$i] =~ s/\s+([A-Z])\s+/ $1. /g; @PB[$i] =~ s/^([A-Z])\s+/$1. /; # add back dots to capital letter first or middle names

              $kw = @DE[$i]; $kw =~ s/\(\d+\) //g; $kw =~ s/ \(\d+\)//g; @KW[$i] = $kw; 
              $tmp = @BT[$i]; $repcolon = ($tmp =~ s/\://g);
              if( $repcolon > 1 || @PG[$i] !~ m/[mclxvi\d]+/ || @PB[$i] =~ m/\;/ || @BT[$i] !~ m/\w+/ || @ED[$i] !~ m/\w+/ || @PB[$i] !~ m/\w+/ || @AD[$i] !~ m/\w+/ || (@VO[$i] =~ m/\d+/ && @SE[$i] !~ m/\w+/)){
                $problcl++;
                if($problcl==1){ print OUT "\n" .'%INCOLLECTION entries may be incomplete. Please check manually. (This problem can be due to a non-standard entry in WebSpirs.)'. "\n" ; warn 'There were @INCOLLECTION entries with problems. See head of output file for details.'. "\n". 'Error occured';}
                print OUT "\%$i\: @AU[$i], @TI[$i] \n";
                }
    }
    elsif(@DT[$i] =~ m/Dissertation/){
              # print OUT "Got a PHDTHESIS. $i\:". @SO[$i] ." \n";
              $_ = @PB[$i];    # structure is like "Ph.D.  University of Pennsylvania 1998"
              /Ph\.D\.\s+([\w+\s+\{\}]+)\s+\d+/;
              @SC[$i]=$1 ;
              $kw = @DE[$i]; $kw =~ s/\(\d+\) //g; $kw =~ s/ \(\d+\)//g; @KW[$i] = $kw; 
              if(@SC[$i] !~ m/\w+/){
                $problph++;
                if($problph==1){ print OUT "\n" .'%PHDTHESIS entries may be incomplete. Please check manually. (This problem can be due to a non-standard entry in WebSpirs.)'. "\n" ; warn 'There were @PHDTHESIS entries with problems. See head of output file for details.'. "\n". 'Error occured';}
                print OUT "\%$i\: @AU[$i], @TI[$i] \n";
                }
    }
    
# Additional treatments

# Remove second English titles
@TI[$i] =~ s/\.\s+\([a-zA-Z0-9\,\.\s\{\}\-\'\`]+\.\)\s*$//;

# Reset volume and number entries to avoid BibTeX errors for Collective-Volume-Articles (loosing information here)
if((@DT[$i] =~ m/Collective-Volume-Article/ || @DT[$i] =~ m/Book/) && @NO[$i] =~ m/\d+/ && @SE[$i] !~ m/\w+/){@VO[$i] = @NO[$i]; @NO[$i] = "";}  
if((@DT[$i] =~ m/Collective-Volume-Article/ || @DT[$i] =~ m/Book/) && @NO[$i] =~ m/\d+/ && @VO[$i] =~ m/\d+/){
    if($option =~ m/\-v/){@NO[$i] = ""}
    else                 {@VO[$i] = ""}
    }  
if(@JO[$i] =~ m/Brookings Papers/){
    if(@NO[$i] =~ m/0/){@NO[$i] = ""}
    if(@VO[$i] =~ m/0/ && @NO[$i] =~ m/\d+/){@VO[$i] = @PY[$i]}
        else                                {@VO[$i] = ""}
    }

# Remove colliding interpunctuation, and other adjustments
@TI[$i] =~ s/\?\:/?/g; @TI[$i] =~ s/\?\./?/g;
@AB[$i] =~ s/\?\:/?/g; @AB[$i] =~ s/\?\./?/g;
@KW[$i] =~ s/\?\:/?/g; @KW[$i] =~ s/\?\./?/g;
@BT[$i] =~ s/\?\:/?/g; @BT[$i] =~ s/\?\./?/g;
@TI[$i] =~ s/\.\'/'/g; @BT[$i] =~ s/\.\'/'/g; @TI[$i] =~ s/\.\'\'/''/g; @BT[$i] =~ s/\.\'\'/''/g;  # Only at end of string
@TI[$i] =~ s/\,\'/'/g; @BT[$i] =~ s/\,\'/'/g; @TI[$i] =~ s/\,\'\'/''/g; @BT[$i] =~ s/\,\'\'/''/g;  # Only at end of string
@TI[$i] =~ s/\;\'/'/g; @BT[$i] =~ s/\;\'/'/g; @TI[$i] =~ s/\;\'\'/''/g; @BT[$i] =~ s/\;\'\'/''/g;  # Only at end of string
if($option =~ m/\-q/){@TI[$i] =~ s/\'\'/'/g; @TI[$i] =~ s/\`\`/`/g; @BT[$i] =~ s/\'\'/'/g; @BT[$i] =~ s/\`\`/`/g; }
 
# Insert right punctuation in names
@AU[$i] =~ s/\s([A-Z])\s+/ $1. /g; @AU[$i] =~ s/\s([A-Z])\s+/ $1. /g;
@AU[$i] =~ s/\s([A-Z])\,\s+/ $1., /g;
@AU[$i] =~ s/\s([A-Z])$/ $1./; @AU[$i] =~ s/\s([A-Z])$/ $1./;
@ED[$i] =~ s/\s([A-Z])\s+/ $1. /g; @ED[$i] =~ s/\s([A-Z])\s+/ $1. /g;
@ED[$i] =~ s/\s([A-Z])\,\s+/ $1., /g;
@ED[$i] =~ s/\s([A-Z])$/ $1./; @ED[$i] =~ s/\s([A-Z])$/ $1./;
@AU[$i] =~ s/World Bank/{World Bank}/;
@ED[$i] =~ s/World Bank/{World Bank}/;
@AU[$i] =~ s/\{//g; @AU[$i] =~ s/\}//g;
@ED[$i] =~ s/\{//g; @ED[$i] =~ s/\}//g;
@AU[$i] =~ s/\,\s+([a-zA-Z]+)\s+([a-z]+)\s+and/\, $1\{-\}$2 and/g; @AU[$i] =~ s/\,\s+([a-zA-Z]+)\s+([a-z]+)$/\, $1\{-\}$2/g;
@ED[$i] =~ s/\,\s+([a-zA-Z]+)\s+([a-z]+)\s+and/\, $1\{-\}$2 and/g; @ED[$i] =~ s/\,\s+([a-zA-Z]+)\s+([a-z]+)$/\, $1\{-\}$2/g;

# Get "et al." citations right for BibTeX styles with full first names
if($option =~ m/\-e/){
    @AU[$i] =~ s/\s+etXal/ {et~al.}/; 
    @ED[$i] =~ s/\s+etXal/ {et~al.}/; 
    }
else{
    @AU[$i] =~ s/\s+etXal/ et al./; 
    @ED[$i] =~ s/\s+etXal/ et al./; 
    }

# Reset "StXXX" to original "St." (confusion is over), and remove trailing blanks
@AU[$i] =~ s/StXXX/St./g;
@AU[$i] =~ s/[\s+\,]+$//;
@ED[$i] =~ s/StXXX/St./g;
@ED[$i] =~ s/[\s+\,]+$//;
@TI[$i] =~ s/StXXX/St./g;
@TI[$i] =~ s/[\s+\,\.\/]+$//;
@JO[$i] =~ s/StXXX/St./g;
@JO[$i] =~ s/[\s+\,\.\/]+$//;
@PY[$i] =~ s/StXXX/St./g;
@PY[$i] =~ s/[\s+\,\.\/]+$//;
@VO[$i] =~ s/StXXX/St./g;
@VO[$i] =~ s/[\s+\,\.\/]+$//;
@NO[$i] =~ s/StXXX/St./g;
@NO[$i] =~ s/[\s+\,\.\/]+$//;
@PG[$i] =~ s/StXXX/St./g;
@PG[$i] =~ s/[\s+\,\.\/]+$//;
@MO[$i] =~ s/StXXX/St./g;
@MO[$i] =~ s/[\s+\,\.\/]+$//;
@RM[$i] =~ s/StXXX/St./g;
if(@RM[$i] =~ m/\/$/){ @RM[$i] =~ s/\-/ /g; } # likely a foreign-language journal title
@RM[$i] =~ s/[\s+\,\.\/]+$//;
@AB[$i] =~ s/StXXX/St./g;
@AB[$i] =~ s/[\s+\,\.\/]+$//;
@KW[$i] =~ s/StXXX/St./g;
@KW[$i] =~ s/[\s+\,\.\/]+$//;
@SO[$i] =~ s/StXXX/St./g;
@SO[$i] =~ s/[\s+\,\.\/]+$//;
@BT[$i] =~ s/StXXX/St./g;
@BT[$i] =~ s/[\s+\,\.\/]+$//;
@PB[$i] =~ s/StXXX/St./g;
@PB[$i] =~ s/[\s+\,\.\/]+$//;
@SE[$i] =~ s/StXXX/St./g;
@SE[$i] =~ s/[\s+\,\.\/]+$//;
@TY[$i] =~ s/StXXX/St./g;
@TY[$i] =~ s/[\s+\,\.\/]+$//;
@CH[$i] =~ s/StXXX/St./g;
@CH[$i] =~ s/[\s+\,\.\/]+$//;
@AD[$i] =~ s/StXXX/St./g;
@AD[$i] =~ s/[\s+\,\.\/]+$//;
@EN[$i] =~ s/StXXX/St./g;
@EN[$i] =~ s/[\s+\,\.\/]+$//;
@IB[$i] =~ s/StXXX/St./g;
@IB[$i] =~ s/[\s+\,\.\/]+$//;
@SC[$i] =~ s/StXXX/St./g;
@SC[$i] =~ s/[\s+\,\.\/]+$//;

$mt = @MO[$i]; $mt =~ s/\.//g; $mt =~ s/\//\-/g; 
if($option !~ m/\-m/){  # Do not perform month correction if option -m was set
    if($mt =~ m/Jan/ && $mt !~ m/Janu/){$mt =~ s/Jan/January/;}
    if($mt =~ m/Feb/ && $mt !~ m/Febr/){$mt =~ s/Feb/February/;}
    if($mt =~ m/Mar/ && $mt !~ m/Marc/){$mt =~ s/Mar/March/;}
    if($mt =~ m/Apr/ && $mt !~ m/Apri/){$mt =~ s/Apr/April/;}
    if($mt =~ m/Jun/ && $mt !~ m/June/){$mt =~ s/Jun/June/;}
    if($mt =~ m/Jul/ && $mt !~ m/July/){$mt =~ s/Jul/July/;}
    if($mt =~ m/Aug/ && $mt !~ m/Augu/){$mt =~ s/Aug/August/;}
    if($mt =~ m/Sept/ && $mt !~ m/Septe/){$mt =~ s/Sept/September/;}
    if($mt =~ m/Sep/ && $mt !~ m/Sept/){$mt =~ s/Sep/September/;}
    if($mt =~ m/Oct/ && $mt !~ m/Octo/){$mt =~ s/Oct/October/;}
    if($mt =~ m/Nov/ && $mt !~ m/Nove/){$mt =~ s/Nov/November/;}
    if($mt =~ m/Dec/ && $mt !~ m/Dece/){$mt =~ s/Dec/December/;}
    if($mt =~ m/Win/ && $mt !~ m/Wint/){$mt =~ s/Win/Winter/;}
    if($mt =~ m/Sum/ && $mt !~ m/Summ/){$mt =~ s/Sum/Summer/;}
    }
@MO[$i] = $mt;
$nm = @NO[$i]; $nm =~ s/\//\-/g; @NO[$i] = $nm;
# $vo = @VO[$i]; $vo =~ s/\//\\\//g; @VO[$i] = $vo;
if(@SO[$i] =~ m/@PB[$i]/){@SO[$i]="";}  # Avoids error of repeating publisher in source

} # End data preparation loops


# Create different BibTeX keys if option [-k] is set
if($option =~ m/\-k/){
    for(my $i=$count;$i>=1;$i--){
      if(@DT[$i] =~ m/Collective-Volume-Article/){$_ = @ED[$i];}  # Use if future WebSpirs version return to providing the editors
      else                                       {$_ = @AU[$i];}
      /\s+and\s+([\w+\-\`\']+)\,([\s+\w+\-\`\'\.]+)\s+and\s+([\w+\-\`\']+)\,/;
      $au3 = $3;
      /\s+and\s+([\w+\-\`\']+)\,/;
      $au2 = $1;
      /([\w+\-\`\']+)\,/;
      $au1 = $1;
      if($au3 =~ m/\w+/){
          if($au3 =~ m/(\w\w\w\w\w)/){$_ = $au3; /(\w\w\w\w\w)/; $au3 = $1;}
          if($au2 =~ m/(\w\w\w\w\w)/){$_ = $au2; /(\w\w\w\w\w)/; $au2 = $1;}
          if($au1 =~ m/(\w\w\w\w\w)/){$_ = $au1; /(\w\w\w\w\w)/; $au1 = $1;}
      }
      else {
          if($au2 =~ m/(\w\w\w\w\w\w)/){$_ = $au2; /(\w\w\w\w\w\w)/; $au2 = $1;}
          if($au1 =~ m/(\w\w\w\w\w\w)/){$_ = $au1; /(\w\w\w\w\w\w)/; $au1 = $1;}
      }
      $yr = @PY[$i]-1900; if($yr>99){$yr=$yr-100}; if($yr<10){$yr="0".$yr}; 
      @BIBKEY[$i]=$au1.$au2.$au3.$yr; @BIBKEY[$i]=~ s/\'//;
      if(@DT[$i] =~ m/Collective-Volume-Article/){ 
        # Because current WebSpirs version does not provide editors, use first eight letters in first words of title meanwhile
        $_ = @BT[$i]; 
        $_ =~ s/ //g; $_ =~ s/\{//g; $_ =~ s/\}//g; $_ =~ s/\`//g; $_ =~ s/\'//g; $_ =~ s/\-//g; 
        /(\w\w\w\w\w\w\w\w)/; @BIBKEY[$i]= $1; 
        @BIBKEY[$i]= @BIBKEY[$i].$yr; 
        } 
      if(@DT[$i] =~ m/Collective-Volume-Article/){@BIBKEY[$i]= @BIBKEY[$i].":"; @BIBREP[$i]=1;}
      for(my $j=$count;$j>=$i+1;$j--){
         if(@BIBKEY[$j] =~ m/@BIBKEY[$i]/ && @BIBKEY[$i] =~ m/@BIBKEY[$j]/){  # Two entries coincide
            @BIBREP[$j]++; if(@BIBREP[$j]<2){@BIBREP[$j]=2}
            @BIBREP[$i]=1;
         }
      }
    }
    for(my $i=1;$i<=$count;$i++){  
      if(@BIBREP[$i]>0){
       if(@DT[$i] =~ m/Collective-Volume-Article/){@BIBKEY[$i] = @BIBKEY[$i].@BIBREP[$i];}
       else{  # If not In-Collection item, replace numbers by letters whenever number less than 25
        @BIBREP[$i] =~ s/25/z/g; @BIBREP[$i] =~ s/24/y/g; @BIBREP[$i] =~ s/23/x/g; @BIBREP[$i] =~ s/22/w/g; @BIBREP[$i] =~ s/21/v/g;
        @BIBREP[$i] =~ s/20/u/g; @BIBREP[$i] =~ s/19/t/g; @BIBREP[$i] =~ s/18/s/g; @BIBREP[$i] =~ s/17/r/g;  @BIBREP[$i] =~ s/16/q/g; @BIBREP[$i] =~ s/15/p/g; @BIBREP[$i] =~ s/14/o/g; @BIBREP[$i] =~ s/13/n/g; @BIBREP[$i] =~ s/12/m/g; @BIBREP[$i] =~ s/11/l/g;
        @BIBREP[$i] =~ s/10/k/g; @BIBREP[$i] =~  s/9/j/g; @BIBREP[$i] =~  s/8/h/g; @BIBREP[$i] =~  s/7/g/g;  @BIBREP[$i] =~  s/6/f/g; @BIBREP[$i] =~  s/5/e/g; @BIBREP[$i] =~  s/4/d/g; @BIBREP[$i] =~  s/3/c/g; @BIBREP[$i] =~  s/2/b/g; @BIBREP[$i] =~  s/1/a/g; 
        @BIBKEY[$i] = @BIBKEY[$i].'-'.@BIBREP[$i];
       }}
    }
}


print OUT "\n\n" ;


for(my $i=1;$i<=$count;$i++){  # Write to output file

if(@DT[$i] =~ m/Journal-Article/){
  if($option =~ m/\-l/)   {print OUT '@ARTICLE{,'. "\n" ;}
  elsif($option =~ m/\-k/){print OUT '@ARTICLE{'.@BIBKEY[$i].','. "\n" ;}
  else                    {print OUT '@ARTICLE{'.$i.','. "\n" ;}
  print OUT 'author =       {' . @AU[$i] . '},' . "\n";
  print OUT 'title =        {' . @TI[$i] . '},' . "\n";
  print OUT 'journal =      {' . @JO[$i] . '},' . "\n";
  print OUT 'year =         {' . @PY[$i] . '},' . "\n";
  print OUT 'volume =       {' . @VO[$i] . '},' . "\n";
  print OUT 'number =       {' . @NO[$i] . '},' . "\n";
  print OUT 'pages =        {' . @PG[$i] . '},' . "\n";
  print OUT 'month =        {' . @MO[$i] . '},' . "\n";
  print OUT 'note =         {' . @RM[$i] . '},' . "\n";
  print OUT 'abstract =     {' . @AB[$i] . '},' . "\n";
  print OUT 'keywords =     {' . @KW[$i] . '},' . "\n";
  print OUT 'source =       {' . @SO[$i] . '},' . "\n";
  if($option =~ m/\-f/){print OUT 'file = F'."\n";}
  print OUT '}'."\n\n";
  }

elsif(@DT[$i] =~ m/Working-Paper/){
  if($option =~ m/\-t/){
  @JO[$i] =~ s/\s+Working\s+Paper(s*)\s+in\s+([a-zA-Z\-\'\`]+)\,\s+([a-zA-Z\-\'\`]+)(\,*)\s+and\s+([a-zA-Z\-\'\`]+)//g; @JO[$i] =~ s/\s+Discussion\s+Paper(s*)\s+in\s+([a-zA-Z\-\'\`]+)\,\s+([a-zA-Z\-\'\`]+)(\,*)\s+and\s+([a-zA-Z\-\'\`]+)//g; @JO[$i] =~ s/\s+working\s+paper(s*)\s+in\s+([a-zA-Z\-\'\`]+)\,\s+([a-zA-Z\-\'\`]+)(\,*)\s+and\s+([a-zA-Z\-\'\`]+)//g; @JO[$i] =~ s/\s+discussion\s+paper(s*)\s+in\s+([a-zA-Z\-\'\`]+)\,\s+([a-zA-Z\-\'\`]+)(\,*)\s+and\s+([a-zA-Z\-\'\`]+)//g; 
  @JO[$i] =~ s/\s+Working\s+Paper(s*)\s+in\s+([a-zA-Z\-\'\`]+)\s+and\s+([a-zA-Z\-\'\`]+)//g; @JO[$i] =~ s/\s+Discussion\s+Paper(s*)\s+in\s+([a-zA-Z\-\'\`]+)\s+and\s+([a-zA-Z\-\'\`]+)//g; @JO[$i] =~ s/\s+working\s+paper(s*)\s+in\s+([a-zA-Z\-\'\`]+)\s+and\s+([a-zA-Z\-\'\`]+)//g; @JO[$i] =~ s/\s+discussion\s+paper(s*)\s+in\s+([a-zA-Z\-\'\`]+)\s+and\s+([a-zA-Z\-\'\`]+)//g; 
  @JO[$i] =~ s/\s+Working\s+Paper(s*)\s+in\s+([a-zA-Z\-\'\`]+)//g; @JO[$i] =~ s/\s+Discussion\s+Paper(s*)\s+in\s+([a-zA-Z\-\'\`]+)//g; @JO[$i] =~ s/\s+working\s+paper(s*)\s+in\s+([a-zA-Z\-\'\`]+)//g; @JO[$i] =~ s/\s+discussion\s+paper(s*)\s+in\s+([a-zA-Z\-\'\`]+)//g; 
  @JO[$i] =~ s/\s+Working\s+Paper(s*)//g; @JO[$i] =~ s/\s+Discussion\s+Paper(s*)//g; @JO[$i] =~ s/\s+working\s+paper(s*)//g; @JO[$i] =~ s/\s+discussion\s+paper(s*)//g; 
# (avoid confusion; some institutions have both working papers and technical papers; see NBER) @JO[$i] =~ s/\s+Technical\s+Report(s*)//g; @JO[$i] =~ s/\s+technical\s+report(s*)//g; 
# (avoid confusion; some institutions have both working papers and technical papers; see NBER) @JO[$i] =~ s/\s+Technical\s+Paper(s*)//g; @JO[$i] =~ s/\s+technical\s+paper(s*)//g; 
  @JO[$i] =~ s/\s+series\s+in\s+([a-zA-Z\-\'\`]+)//g;   @JO[$i] =~ s/\s+Series\s+in\s+([a-zA-Z\-\'\`]+)//g; 
  @JO[$i] =~ s/\s+series//g;   @JO[$i] =~ s/\s+Series//g; 
  if($option =~ m/\-l/)   {print OUT '@TECHREPORT{,'. "\n" ;}
  elsif($option =~ m/\-k/){print OUT '@TECHREPORT{'.@BIBKEY[$i].','. "\n" ;}
  else                    {print OUT '@TECHREPORT{'.$i.','. "\n" ;}
  print OUT 'author =       {' . @AU[$i] . '},' . "\n";
  print OUT 'title =        {' . @TI[$i] . '},' . "\n";
  print OUT 'institution =  {' . @JO[$i] . '},' . "\n";
  print OUT 'address =      {' . @AD[$i] . '},' . "\n";
  print OUT 'year =         {' . @PY[$i] . '},' . "\n";
  print OUT 'month =        {' . @MO[$i] . '},' . "\n";
  print OUT 'type =         {' . @TY[$i] . '},' . "\n";
  print OUT 'number =       {' . @VO[$i] . '},' . "\n";
  print OUT 'note =         {' . @RM[$i] . '},' . "\n";
  print OUT 'abstract =     {' . @AB[$i] . '},' . "\n";
  print OUT 'keywords =     {' . @KW[$i] . '},' . "\n";
  print OUT 'source =       {' . @SO[$i] . '},' . "\n";
  if($option =~ m/\-f/){print OUT 'file = F'."\n";}
  print OUT '}'."\n\n";
   }
  else {
  if($option =~ m/\-l/)   {print OUT '@ARTICLE{,'. "\n" ;}
  elsif($option =~ m/\-k/){print OUT '@ARTICLE{'.@BIBKEY[$i].','. "\n" ;}
  else                    {print OUT '@ARTICLE{'.$i.','. "\n" ;}
  print OUT 'author =       {' . @AU[$i] . '},' . "\n";
  print OUT 'title =        {' . @TI[$i] . '},' . "\n";
  print OUT 'journal =      {' . @JO[$i] . '},' . "\n";
  print OUT 'note =         {' . @RM[$i] . '},' . "\n";
  print OUT 'year =         {' . @PY[$i] . '},' . "\n";
  print OUT 'volume =       {' . @VO[$i] . '},' . "\n";
  print OUT 'month =        {' . @MO[$i] . '},' . "\n";
  print OUT 'abstract =     {' . @AB[$i] . '},' . "\n";
  print OUT 'keywords =     {' . @KW[$i] . '},' . "\n";
  print OUT 'source =       {' . @SO[$i] . '},' . "\n";
  if($option =~ m/\-f/){print OUT 'file = F'."\n";}
  print OUT '}'."\n\n";
  }
  }

elsif(@DT[$i] =~ m/Collective-Volume-Article/){
  if($option =~ m/\-l/)   {print OUT '@INCOLLECTION{,'. "\n" ;}
  elsif($option =~ m/\-k/){print OUT '@INCOLLECTION{'.@BIBKEY[$i].','. "\n" ;}
  else                    {print OUT '@INCOLLECTION{'.$i.','. "\n" ;}
  print OUT 'author =       {' . @AU[$i] . '},' . "\n";
  print OUT 'title =        {' . @TI[$i] . '},' . "\n";
  print OUT 'pages =        {' . @PG[$i] . '},' . "\n";
  print OUT 'booktitle =    {' . @BT[$i] . '},' . "\n";
  print OUT 'publisher =    {' . @PB[$i] . '},' . "\n";
  print OUT 'year =         {' . @PY[$i] . '},' . "\n";
  print OUT 'editor =       {' . @ED[$i] . '},' . "\n";
  print OUT 'volume =       {' . @VO[$i] . '},' . "\n";
  print OUT 'number =       {' . @NO[$i] . '},' . "\n";
  print OUT 'series =       {' . @SE[$i] . '},' . "\n";
  print OUT 'type =         {' . @TY[$i] . '},' . "\n";
  print OUT 'chapter =      {' . @CH[$i] . '},' . "\n";
  print OUT 'address =      {' . @AD[$i] . '},' . "\n";
  print OUT 'edition =      {' . @EN[$i] . '},' . "\n";
  print OUT 'month =        {' . @MO[$i] . '},' . "\n";
  print OUT 'note =         {' . @RM[$i] . '},' . "\n";
  print OUT 'isbn =         {' . @IB[$i] . '},' . "\n";
  print OUT 'abstract =     {' . @AB[$i] . '},' . "\n";
  print OUT 'keywords =     {' . @KW[$i] . '},' . "\n";
  print OUT 'source =       {' . @SO[$i] . '},' . "\n";
  if($option =~ m/\-f/){print OUT 'file = F'."\n";}
  print OUT '}'."\n\n";
  }

elsif(@DT[$i] =~ m/Book/ && @DT[$i] !~ m/Book-Review/){
  if($option =~ m/\-l/)   {print OUT '@BOOK{,'. "\n" ;}
  elsif($option =~ m/\-k/){print OUT '@BOOK{'.@BIBKEY[$i].','. "\n" ;}
  else                    {print OUT '@BOOK{'.$i.','. "\n" ;}

  if(@AU[$i] =~ s/\,\s+ed[s]*//){ 
        # print OUT 'Got an editor '. "$i \n";
        print OUT 'editor =       {' . @AU[$i] . '},' . "\n";}
  else{ print OUT 'author =       {' . @AU[$i] . '},' . "\n";}
  print OUT 'title =        {' . @TI[$i] . '},' . "\n";
  print OUT 'publisher =    {' . @PB[$i] . '},' . "\n";
  print OUT 'year =         {' . @PY[$i] . '},' . "\n";
  print OUT 'volume =       {' . @VO[$i] . '},' . "\n";
  print OUT 'number =       {' . @NO[$i] . '},' . "\n";
  print OUT 'series =       {' . @SE[$i] . '},' . "\n";
  print OUT 'address =      {' . @AD[$i] . '},' . "\n";
  print OUT 'edition =      {' . @EN[$i] . '},' . "\n";
  print OUT 'month =        {' . @MO[$i] . '},' . "\n";
  print OUT 'note =         {' . @RM[$i] . '},' . "\n";
  print OUT 'isbn =         {' . @IB[$i] . '},' . "\n";
  print OUT 'abstract =     {' . @AB[$i] . '},' . "\n";
  print OUT 'keywords =     {' . @KW[$i] . '},' . "\n";
  print OUT 'source =       {' . @SO[$i] . '},' . "\n";
  if($option =~ m/\-f/){print OUT 'file = F'."\n";}
  print OUT '}'."\n\n";
  }

elsif(@DT[$i] =~ m/Dissertation/){
  if($option =~ m/\-l/)   {print OUT '@PHDTHESIS{,'. "\n" ;}
  elsif($option =~ m/\-k/){print OUT '@PHDTHESIS{'.@BIBKEY[$i].','. "\n" ;}
  else                    {print OUT '@PHDTHESIS{'.$i.','. "\n" ;}
  print OUT 'author =       {' . @AU[$i] . '},' . "\n";
  print OUT 'title =        {' . @TI[$i] . '},' . "\n";
  print OUT 'school =       {' . @SC[$i] . '},' . "\n";
  print OUT 'year =         {' . @PY[$i] . '},' . "\n";
  print OUT 'type =         {' . @TP[$i] . '},' . "\n";
  print OUT 'address =      {' . @JO[$i] . '},' . "\n";
  print OUT 'month =        {' . @MO[$i] . '},' . "\n";
  print OUT 'note =         {' . @RM[$i] . '},' . "\n";
  print OUT 'abstract =     {' . @AB[$i] . '},' . "\n";
  print OUT 'keywords =     {' . @KW[$i] . '},' . "\n";
  print OUT 'source =       {' . @SO[$i] . '},' . "\n";
  if($option =~ m/\-f/){print OUT 'file = F'."\n";}
  print OUT '}'."\n\n";
  }

} # End for() loop for printing

if($noprbdt==0){print OUT "\n" .'%The WebSpirs .dat file did not contain any DT: entry.'. "\n" ; warn 'The WebSpirs .dat file did not contain any DT: entry. Output may  be useless.'. "\n". 'Error occured';}
